shishi_encrypt_iv_etype(3)

NAME
shishi_encrypt_iv_etype - API function

SYNOPSIS
#include <shishi.h>

int shishi_encrypt_iv_etype(Shishi * handle, Shishi_key * key, int keyusage, int32_t etype, const char * iv, size_t ivlen, const char * in, size_t inlen, char ** out, size_t * outlen);

ARGUMENTS

Shishi * handle
    shishi handle as allocated by shishi_init().

Shishi_key * key
    key to encrypt with.

int keyusage
    integer specifying what this key is encrypting.

int32_t etype
    integer specifying what cipher to use.

const char * iv
    input array with initialization vector

size_t ivlen
    size of input array with initialization vector.

const char * in
    input array with data to encrypt.

size_t inlen
    size of input array with data to encrypt.

char ** out
    output array with newly allocated encrypted data.

size_t * outlen
    output variable with size of newly allocated output array.

DESCRIPTION
Encrypts data as per encryption method using specified initialization vector and key. The key actually used is derived using the key usage. If key usage is 0, no key derivation is used. The OUT buffer must be deallocated by the caller. The next IV is lost, see shishi_encrypt_ivupdate_etype if you need it.

Note that DECRYPT(ENCRYPT(data)) does not necessarily yield data exactly. Some encryption types add pad to make the data fit into the block size of the encryption algorithm. Furthermore, the pad is not guaranteed to look in any special way, although existing implementations often pad with the zero byte. This means that you may have to "frame" data, so it is possible to infer the original length after decryption. Compare ASN.1 DER which contains such information.

RETURN VALUE
Returns SHISHI_OK iff successful.

REPORTING BUGS
Report bugs to <bug-shishi@gnu.org>. GNU Shishi home page: http://www.gnu.org/software/shishi/ General help using GNU software: http://www.gnu.org/gethelp/

COPYRIGHT
Copyright © 2002-2022 Simon Josefsson.
Copying and distribution of this file, with or without modification, are permitted in any medium without royalty provided the copyright notice and this notice are preserved.

SEE ALSO
The full documentation for shishi is maintained as a Texinfo manual. If the info and shishi programs are properly installed at your site, the command

    info shishi

should give you access to the complete manual.